#ifndef _GRP_H
#define _GRP_H

#ifndef _FEATURES_H
#include <features.h>
#endif

#if defined(__USE_SVID) || defined (__USE_GNU)
#ifndef _STDIO_H
#define __need_FILE
#include <stdio.h>
#endif
#endif /* SVID or GNU*/

#include <bits/types.h>

#define __need_size_t
#include <stddef.h>

__BEGIN_DECLS

/* For the Single Unix specification we must define this type here.  */
#if defined __USE_XOPEN && !defined __gid_t_defined
typedef __gid_t gid_t;
# define __gid_t_defined 1
#endif

struct group
{
  char *gr_name;    /* The name of the group        */
  __gid_t gr_gid;    /* The numerical group ID       */
  char **gr_mem;    /* array of member names        */
  char *gr_passwd;/* The encrypted group password */
};

#if defined (__USE_SVID) || defined (__USE_MISC) || defined (__USE_BSD)
__EXTERN void   setgrent __P ((void));
__EXTERN void   endgrent __P ((void));
__EXTERN struct group * getgrent __P ((void));
#endif /* SVID or misc or BSD */

#ifdef __USE_SVID
__EXTERN struct group * fgetgrent __P ((FILE *f));
#endif /* __USE_SVID */

__EXTERN struct group * getgrgid __P ((__gid_t gid));
__EXTERN struct group * getgrnam __P ((const char *name));

int getgrgid_r(__gid_t gid, struct group *grp, char *buf, size_t buflen, struct group **result);
int getgrnam_r(const char *name, struct group *grp, char *buf, size_t buflen, struct group **result);

#ifdef __USE_BSD
__EXTERN int initgroups __P ((const char* __user, __gid_t __group));
__EXTERN int setgroups __P ((size_t __count, const __gid_t* __groups));
#endif

__END_DECLS

#endif /* _GRP_H */
